(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: NEJDELSI.PAS                                                   *)
(*  Obsah: program pro nalezeni nejdelsiho useku slozeneho ze stejnych     *)
(*         pismen v zadane posloupnosti znaku                              *)
(*  Posledni uprava: 31.12.2009                                            *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program hledani_nejdelsiho_useku_stejnych_znaku;

const DelkaPosl:byte=50; {jak ma byt prohledavana posloupnost dlouha (lze prenastavit)}

var posloupnost:string; {v tomhle budeme vyhledavat}
    delka, {pro pocitani delky zkoumaneho useku}
    MaxDelka, {pro pamatovani nejvetsi nalezene delky}
    ZacatekUseku, {pro pamatovani, kde zacina nejdelsi nalezeny usek}
    i:byte; {pomocne pocitadlo}
    volba:char; {pro vstup od uzivatele}

BEGIN
randomize; {inicializace generatoru nahodnych cisel, aby funkce Random spravne fungovala}
posloupnost:='Jeste nebyla zadana!'; {inicializace posloupnosti nejakou hodnotou}

{Uvodni predstaveni se uzivateli:}
writeln('Program pro hledani nejdelsiho useku stejnych znaku');
writeln('===================================================');
writeln('               (c) Mircosoft 2009');
writeln;

 repeat {vnejsi cyklus programu}

 {menu:}
 writeln(' Vyberte si, co chcete delat');
 writeln(' (zadejte prislusne pismeno a stisknete Enter):');
 writeln('   N - Vytvorit posloupnost z uplne nahodnych znaku');
 writeln('   V - Vytvorit posloupnost z nahodnych znaku, ale s vetsi');
 writeln('       pravdepodobnosti souvislych useku');
 writeln('   D - Zadat delku posloupnosti pro nahodne tvoreni (aktualne ',delkaposl,')');
 writeln('   R - Zadat celou posloupnost rucne');
 writeln('   H - Vyhledat v posloupnosti nejdelsi usek stejnych pismen');
 writeln('   K - Konec');
 write  (' Vase volba: ');
 readln(volba); {nacteni pismena z klavesnice}
 volba:=upcase(volba); {prevod na velke pismeno, aby se zjednodusilo testovani}

 writeln; {vynechani radku mezi menu a vypisem vysledku}

 {zpracovani zadane volby:}
 case volba of
  'N':begin {posloupnost z nahodnych znaku}
      for i:=1 to delkaposl do posloupnost[i]:=chr(random(26)+ord('A'));
      {Co tim chtel basnik rici:
       1) 26 je pocet pismen v abecede.
       2) Random z nej vyrobi nahodne cislo od 0 do 25.
       3) Prictenim ord('A') se z rozsahu 0..25 dostaneme na rozsah 65..90
          (tedy ord('A')..ord('Z')).
       4) Funkci Chr prevedeme ziskane cislo na znak (nekde mezi #65..#90,
          tedy 'A'..'Z').
       5) To cele jede pro kazdy prvek posloupnosti.}
      posloupnost[0]:=chr(delkaposl);
      {Do nulteho znaku posloupnosti jsme vlozili jeji delku a tim jsme
       ziskali platny retezec (string), se kterym se da dale pracovat
       standardnimi prostredky Pascalu.}
      writeln('Posloupnost vytvorena.');
      end;
  'V':begin {posloupnost z ne tak uplne nahodnych znaku}
      for i:=1 to delkaposl do if (i>1)and(random(10)<3)
                                 then posloupnost[i]:=posloupnost[i-1]
                                 else posloupnost[i]:=chr(random(26)+ord('A'));
      {Coz znamena:
       1) Hodime si desetistennou kostkou (random(10)) a dostaneme nahodne
          cislo v rozsahu 0..9.
       2) Kdyz padlo cislo mensi nez 3 (hodnotu 3 jsme si jen tak zvolili,
          pouzit muzeme samozrejme i jinou), zkopirujeme predchozi znak.
          S uplne prvnim znakem to pochopitelne nejde, protoze pred nim neni
          nic, co bychom mohli zkopirovat, proto ta podminka if i>1.
       3) Kdyz padlo cislo vetsi >=3, vlozime do posloupnosti novy nahodny
          znak stejnym zpusobem jako minule.}
      posloupnost[0]:=chr(delkaposl); {nastaveni delky, to uz znate}
      writeln('Posloupnost vytvorena.');
      end;
  'D':begin {zadani delky}
      write('Zadejte novou delku: ');
      readln(delkaposl);
      {Kdyby nahodou uzivatel zadal misto cisla nesmysl, program spadne s
       chybou "Invalid numeric format". Tomu by se dalo zabranit jinym
       zpusobem nacteni a naslednym pouzitim funkce Val (viz help), ale ted
       se tim nebudeme zdrzovat.}
      end;
  'R':begin {rucni zadani posloupnosti}
      write('Zadejte posloupnost znaku: ');
      readln(posloupnost); {delku v nultem znaku nastavi Readln automaticky,
                            takze se o ni nemusime starat}
      writeln('Posloupnost zadana.');
      end;
  'H':begin {to nejdulezitejsi z celeho programu :-)}

      {nalezeni nejdelsiho souvisleho useku stejnych znaku:}
      MaxDelka:=0; {jeste jsme nic nenasli, tak tohle vynulujeme}
      for i:=1 to length(posloupnost) do {pro kazdy znak v posloupnosti}
       begin
       delka:=1; {jsme na item znaku a jeste nevime, co je za nim}
       {od iteho znaku se pricitanim Delky posouvame doprava:}
       while (i+delka<=length(posloupnost)) {dokud jeste jsme uvnitr posloupnosti...}
             and (posloupnost[i+delka]=posloupnost[i]) {...a tenhle znak je stejny jako ity...}
         do inc(delka); {...posuneme se o jeden znak dal (inc(delka) je totez jako delka:=delka+1).}
       {porovname se zatim nejdelsi delkou, jakou jsme dosud nasli:}
       if delka>maxdelka {jestli to, co jsme nasli ted, je delsi}
         then begin
              maxdelka:=delka; {zapamatujeme si novou nejvetsi delku...}
              zacatekuseku:=i; {...a pozici, na ktere tento usek zacina}
              end;
       end;

      {Rekapitulace: ted je v promenne MaxDelka ulozena delka nejdelsiho
      useku stejnych znaku a v promenne ZacatekUseku je index, na kterem
      tento usek zacina.}

      {vypis vysledku na obrazovku:}
      writeln('Posloupnost prohledana, nejdelsi souvisly usek je podtrzen (~~~):');
      writeln(posloupnost); {vypsani posloupnosti}
      {ted podtrhneme nalezeny usek:}
      for i:=1 to zacatekuseku-1 do write(' '); {mezerami vyplnime oblast
       pred usekem (kdyby zacinal uz na prvnim znaku, vysla by koncova mez
       cyklu 0, takze by se cyklus neprovedl ani jednou.}
      for i:=1 to maxdelka do write('~'); {a podtrhneme usek pomoc vlnovek}
      writeln;

      end;
  'K':writeln('Nashledanou!');
  else writeln('Neplatna volba, zkuste to znovu a lepe.');
  end;

 {oddelovaci cara, aby bylo jasne, ze skoncila jedna iterace vnejsiho cyklu:}
 writeln('---------------------');

 until volba='K'; {vnejsi cyklus konci zadanim volby K}

END.